#ifndef GL_CODE_H_INCLUDED
#define GL_CODE_H_INCLUDED

#ifdef TARGET_ANDROID
//#include "android_api.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "boost/shared_ptr.hpp"
/*#include "boost/thread/thread.hpp"
#include "boost/signal.hpp"
#include "boost/assign.hpp"
#include "boost/bind.hpp"
*/
#include "include/Engine.h"

#include "match3/match3field.h"


class TMatch3Controller
{
public:
	TMatch3Field* Match3Field;


	TMatch3Controller()
		: Match3Field(NULL)
	{
	}

};


//Application class
class TMyApplication : public TApplication
{
public:
	bool Inited;

	TMatch3Controller Match3Controller;
	
	TMyApplication() : Inited(false) { }

	virtual void InnerInit();
	//What to do on init

	virtual void InnerDeinit();
	//What to do on deinit

	virtual void InnerDraw();
	//What to do on draw 

	virtual void InnerUpdate(cardinal timer);
	//What to do on update. timer means how many ms passed since last update
};

#ifndef TARGET_IOS
extern boost::shared_ptr<TMyApplication> App;
#endif

#endif
